# OSM's User Guide Documentation

[![8th OSM Hack.png](assets/320px-8th_OSM_Hack.png)](https://osm.etsi.org/wikipub/index.php/8th_OSM_Hackfest)

1. [Quickstart](01-quickstart.md)
   - Get started quickly and become familiar with the most common operations in OSM
2. [OSM Architecture and Functions](02-osm-architecture-and-functions.md)
   - Understanding what OSM offers and how it works
3. [Installing OSM](03-installing-osm.md)
   - How to install OSM: from one-liner installs to highly customized setups
4. [Setup of Virtual Infrastructure Managers (VIMs)](04-vim-setup.md)
   - How to setup a VIM to use it from OSM
5. [OSM Usage](05-osm-usage.md)
   - Learn how to run common OSM operations
6. [OSM platform configuration](06-osm-platform-configuration.md)
   - Setting up your OSM
7. [What to read next](07-what-to-read-next.md)
   - Where can I learn more? Some useful links
8. [How to contribute to documentation](08-how-to-contribute-to-docs.md)
   - How can I help to improve this documentation?
9. [ANNEX 1: Troubleshooting](09-troubleshooting.md)
10. [ANNEX 2: Reference of OSM Client commands and library](10-osm-client-commands-reference.md)
11. [ANNEX 3: Reference of OSM's Information Model](11-osm-im.md)
12. [ANNEX 4: Reference of OSM's Northbound Interface](12-osm-nbi.md)
13. [ANNEX 5: OpenVIM installation](13-openvim-installation.md)
14. [ANNEX 6: Tests to validate VIM capabilities from OSM](14-tests-for-vim-validation.md)
15. [ANNEX 7: Kubernetes installation and requirements](15-k8s-installation.md)
16. [ANNEX 8: Setting up an LXD Cluster](16-lxd-cluster.md)
